Skip to content

API Endpoint Reference (1.0)

Tenovos offers a REST API for partner and customer integrations. This API provides a RESTful endpoint, token-based authorization, HTTP methods for operations, and JSON-formatted payloads. Use this API to incorporate Tenovos functionality into your own application.

This API is up-versioned when a breaking change is introduced such as

  • a change in the format of the response data for one or more calls
  • a change in the request or response type (i.e. changing an integer to a float)
  • removing any part of the API.

This API is not up-versioned for non-breaking changes such as

  • new endpoints
  • new response parameters
  • new optional request parameters
Download OpenAPI description
Languages
Servers
https://enterprise.services.tenovos.io/content-store-v1
https://enterprise-2.services.tenovos.io/content-store-v1
https://enterprise3.services.tenovos.io/content-store-v1
https://enterprise-4.services.tenovos.io/content-store-v1

Action Operations

Invoke the Action API to retrieve information about invoked Actions.

Operations

Asset Operations

Invoke the Asset API to create, retrieve, manipulate, and share Assets. This API also provides operations to manage Asset relationships and download Asset content.

Operations

Remove a relationship between Assets.

Request

Remove a relationship between a primary Asset and one or more secondary Assets. Specify the primary Asset Object ID as a path parameter. Specify the secondary Asset Object IDs and Link Types as an array in the request body.

The user requesting the Asset relationships must have view access to both the primary Asset and the related Assets in order to relationships and the related Assets.

Security
ApiKeyAuth or BasicAuth
Path
idstringrequired

Asset object ID

Headers
X-API-Keystringrequired

Customer-specific API key required to invoke API.

Authorizationstringrequired

Provided by Authentication Token creation operation

AccessTokenstringrequired

JWT token provided by Authentication Token creation operation.

Bodyapplication/jsonrequired

The Request Body is a JSON object.

secondaryIdsArray of objects(RelationshipDeleteRequest_secondaryIds)
curl -i -X PATCH \
  'https://enterprise.services.tenovos.io/content-store-v1/asset/{id}/link' \
  -H 'AccessToken: string' \
  -H 'Authorization: string' \
  -H 'Content-Type: application/json' \
  -H 'X-API-Key: YOUR_API_KEY_HERE' \
  -d '{
    "secondaryIds": [
      {
        "id": "f81769d1-8e93-4af7-856e-56ea30ec1038",
        "linkType": "child"
      }
    ]
  }'

Responses

Successful operation with relationshipId

Bodyapplication/jsonArray [
Any of:
statusstring
Example: "success"
messagestring
Example: "Relationship deleted successfully"
relationshipIdstring
Example: "f81769d1-8e93-4af7-856e-56ea30ec1038-c91f8b40-a7ba-476c-b52f-341952f6c250"
]
Response
application/json
[ { "status": "success", "message": "Relationship deleted successfully", "relationshipId": "f81769d1-8e93-4af7-856e-56ea30ec1038-c91f8b40-a7ba-476c-b52f-341952f6c250" } ]

Get the version history of an Asset.

Request

Retrieve a list of all versions of an Asset by specifying an Object ID or Original File ID in the request path.

The user requesting the Asset must have view access to the Asset in order to retrieve the Asset version history.

Security
ApiKeyAuth or BasicAuth
Path
idstringrequired

Object ID or File ID of the asset.

Headers
X-API-Keystringrequired

Customer-specific API key required to invoke API.

Authorizationstringrequired

Provided by Authentication Token creation operation

AccessTokenstringrequired

JWT token provided by Authentication Token creation operation.

curl -i -X GET \
  'https://enterprise.services.tenovos.io/content-store-v1/asset/{id}/version' \
  -H 'AccessToken: string' \
  -H 'Authorization: string' \
  -H 'X-API-Key: YOUR_API_KEY_HERE'

Responses

Successful operation

Bodyapplication/jsonArray [
createdBystring(uuid)

User ID who created this Asset

Example: "7d675ef0-f423-11e9-8071-89c0c405214e"
createdEpochinteger

Creation time in milliseconds

Example: 1608745510614
currentVersionstring

Current version flag

Enum"Y""N"
Example: "Y"
customerIdstring

Customer ID of Created By User's Account

Example: "123203455"
fileIdstring(uuid)

Asset File ID

filenamestring

Asset content file name

Example: "adventure-alps-beautiful-landscape-2444403.jpg"
fileStatestring

Asset content file state

Enum"available""recycle bin"
lastUpdatedByany(uuid)

User ID who last updated the asset

Example: "7d675ef0-f423-11e9-8071-89c0c40133ds"
lastUpdatedEpochinteger

Last update time in milliseconds

Example: 1612333543954
metadataArray of MetadataStringValue (object) or MetadataRestrictedVocabularyValue (object) or MetadataDateValue (object) or MetadataMultiValue (object) or MetadataGridValue (object)(MetadataDocument)

Array of metadata attributes

metadataDenormalizedobject

Metadata document is a flat list of metadata attributes and values, where values are either in text values or foreign keys / referential values

metadataStatestring

Asset metadata state

Enum"available""recycle bin"
Example: "available"
metadataTemplateIdstring(uuid)

Metadata Template ID

Example: "ea6eb24d-adef-4380-bd02-f64f567c437f"
objectIdstring(uuid)

Asset Object ID

Example: "e6f4bd5e-9bea-43cb-b15e-22582fa5322e"
objectTypestring

Asset Object type

Value"Asset"
Example: "Asset"
originalFileIdstring(uuid)

The ID of the original version of the file

Example: "003391e4-e78a-4186-b2d7-b5d4fcbe445d"
renditionsobject(AssetRenditions)

Renditions details

securityTemplateIdsArray of strings(uuid)

List of Security Template IDs

Example: ["7d6f4e30-f423-11e9-8071-89c0c4052156"]
securityDenormalizedArray of objects(AssetSecurityDenormalized)
technicalMetadataobject(AssetTechnicalMetadata)

Technical metadata about the asset

presignedURLstring

The URL to download the file. Populated for download requests.

linkTypestring
relationshipIdstring
secondaryIdstring
versionNumberintegerDeprecated

Asset version number

]
Response
application/json
[ { "createdBy": "7d675ef0-f423-11e9-8071-89c0c405214e", "createdEpoch": 1608745510614, "currentVersion": "Y", "customerId": "123203455", "fileId": "a1c6a2ab-4b01-4253-b4c9-70e04b3b48fc", "filename": "adventure-alps-beautiful-landscape-2444403.jpg", "fileState": "available", "lastUpdatedBy": "7d675ef0-f423-11e9-8071-89c0c40133ds", "lastUpdatedEpoch": 1612333543954, "metadata": [ … ], "metadataDenormalized": {}, "metadataState": "available", "metadataTemplateId": "ea6eb24d-adef-4380-bd02-f64f567c437f", "objectId": "e6f4bd5e-9bea-43cb-b15e-22582fa5322e", "objectType": "Asset", "originalFileId": "003391e4-e78a-4186-b2d7-b5d4fcbe445d", "renditions": { … }, "securityTemplateIds": [ … ], "securityDenormalized": [ … ], "technicalMetadata": { … }, "versionNumber": 0, "presignedURL": "string", "linkType": "string", "relationshipId": "string", "secondaryId": "string" } ]

Complete Upload.

Request

Complete/Cancel multipart upload once all parts are uploaded. This endpoint must be called after creating asset when the file is sent in chunks of 100MB each. For files 100MB or less in size this operation is not needed.

Security
ApiKeyAuth or BasicAuth
Headers
X-API-Keystringrequired

Customer-specific API key required to invoke API.

Authorizationstringrequired

Provided by Authentication Token creation operation

AccessTokenstringrequired

JWT token provided by Authentication Token creation operation.

Content-Typestringrequired
Value"application/json"
Bodyapplication/jsonrequired

The Request Body must be a JSON array.

fileIdstring(uuid)
filenamestring
filesizeinteger
Example: 335226108
actionstring

Either complete or cancel as the action to finalize the multipart upload. This field is case sensitive.

Enum"complete""cancel"
Example: "complete"
originalFileIdstring(uuid)
uploadIdstring
Example: "gR5XHJZpuDv8UizdpSGuwONje0GbMHnCWXS5zTTVkyVINURV6iraWLhpM7Sy7oy65utAgPcm2FfM4fRp4oVga4ggEzD811aS1tke_F0iIIXX1kV7m6UouytsNE0oL8fzo2Zr2JCqwRyhFTXp98zjdQ--"
partsArray of objects(AssetMultipartUploadRequest_parts)
curl -i -X POST \
  https://enterprise.services.tenovos.io/content-store-v1/asset/complete \
  -H 'AccessToken: string' \
  -H 'Authorization: string' \
  -H 'Content-Type: application/json' \
  -H 'X-API-Key: YOUR_API_KEY_HERE' \
  -d '{
    "fileId": "a1c6a2ab-4b01-4253-b4c9-70e04b3b48fc",
    "filename": "string",
    "filesize": 335226108,
    "action": "complete",
    "originalFileId": "1ebf63d7-819a-4a33-a1cd-00df81f55bd3",
    "uploadId": "gR5XHJZpuDv8UizdpSGuwONje0GbMHnCWXS5zTTVkyVINURV6iraWLhpM7Sy7oy65utAgPcm2FfM4fRp4oVga4ggEzD811aS1tke_F0iIIXX1kV7m6UouytsNE0oL8fzo2Zr2JCqwRyhFTXp98zjdQ--",
    "parts": [
      {
        "partNumber": 1,
        "etag": "6988d46a133c76f49c555deebb8efb8a"
      }
    ]
  }'

Responses

Successful operation

Bodyapplication/json
fileIdstring(uuid)
filenamestring
actionstring
Example: "Complete/Cancel"
originalFileIdstring(uuid)
uploadIdstring
Example: "gR5XHJZpuDv8UizdpSGuwONje0GbMHnCWXS5zTTVkyVINURV6iraWLhpM7Sy7oy65utAgPcm2FfM4fRp4oVga4ggEzD811aS1tke_F0iIIXX1kV7m6UouytsNE0oL8fzo2Zr2JCqwRyhFTXp98zjdQ--"
s3Keystring
Example: "masters/843ec17f-9491-4cfa-b840-faa299973207/2-vid.mp4"
statusstring
Example: "success"
Response
application/json
{ "fileId": "a1c6a2ab-4b01-4253-b4c9-70e04b3b48fc", "filename": "string", "action": "Complete/Cancel", "originalFileId": "1ebf63d7-819a-4a33-a1cd-00df81f55bd3", "uploadId": "gR5XHJZpuDv8UizdpSGuwONje0GbMHnCWXS5zTTVkyVINURV6iraWLhpM7Sy7oy65utAgPcm2FfM4fRp4oVga4ggEzD811aS1tke_F0iIIXX1kV7m6UouytsNE0oL8fzo2Zr2JCqwRyhFTXp98zjdQ--", "s3Key": "masters/843ec17f-9491-4cfa-b840-faa299973207/2-vid.mp4", "status": "success" }

Authentication Operations

Invoke the Authentication API to generate, refresh, and revoke access tokens. An access token is required to perform any authorized API operation.

Operations

Collection Operations

Invoke the Collection API to create, retrieve, edit, and delete Collections. Collections are used to group and catalog related Assets for quick access and consumption. Collections can be configured as:

  • private: Visible only to the user who created the Collection.
  • secured: Visible to shared users with permission.

When retrieving the Assets within a Collection, the requesting user will only see the Assets that the user has access to view. For example, a librarian may see all Assets within a Collection, but a general consumer user may only see a portion of those Assets, due to limited security access.

Operations

Customer Operations

Invoke the Customer API to retrieve Customer account profile information.

Operations

Metadata Operations

Invoke the Metadata API to retrieve Metadata Template to be applied to Assets during Asset creation. A Metadata Template defines a set of Metadata Attributes of varying types, including Text, Date, Controlled Vocabulary, Tabular, and Cascading Attributes. When a Metadata Template is assigned to a new Asset, the corresponding Metadata Attributes will be available for population on the Asset.

Operations

Search Operations

Search for Collections by Collection name.

Perform Asset searches using keywords or Attribute-specific search terms using the Keyword Search endpoint.

Perform a scan on all assets based on search criteria using a cursor to page through the entire result set of assets.

Operations

Security Operations

Invoke the Metadata API to retrieve Security Template information to be applied to Assets during Asset creation or edit.

Operations

User Operations

Invoke the User API to retrieve User profile information.

Operations

Proof Operations

Operations

Cart Operations

Operations